unit vb_zyxel;

interface

uses classes, vb_pvflib, Dialogs, SysUtils;

const
     Mx: Array[0..2] of Array[0..7] of integer =
     (
     ($3800, $5600, $0000, $0000, $0000, $0000, $0000, $0000),
     ($399a, $3a9f, $4d14, $6607, $0000, $0000, $0000, $0000),
     ($3556, $3556, $399A, $3A9F, $4200, $4D14, $6607, $6607)
     );

function zyxeltopvf(fd_in, fd_out: TMemoryStream; nbits: integer; header_out: Tpvf_header): Boolean;
function pvftozyxel(fd_in, fd_out: TMemoryStream; nbits: integer; header_in: Tpvf_header): Boolean;

implementation

function zyxeltopvf(fd_in, fd_out: TMemoryStream; nbits: integer; header_out: Tpvf_header): Boolean;
Var
   s:    state_t;
   a:    SmallInt;
   d:    SmallInt;
   sign: ShortInt;
   e:      Byte;
Begin
 FillChar(s,SizeOf(s),#0);
 a    := 0;
 d    := 5;

 if (nbits = 30) then nbits := 3;

 if ((nbits <> 2) and (nbits <> 3) and (nbits <> 4)) then
  Begin
   result := false;
   exit;
  End;

 Repeat
  Begin
   e := header_out.ReadFunctions.read_bits(fd_in,nbits,s);
   if ((nbits = 4) and (e = 0)) then d := 4;

   if (e shr (nbits - 1)) = 0 Then sign := 1
                              Else sign := -1;
   e := e and bitmask[nbits - 1];
   a := SmallInt((a * 4093 + 2048) shr 12);
   a := SmallInt(a + ((sign * ((e shl 1) + 1) * d) shr 1));

   if ((d and 1) > 0) then Inc(a);

   header_out.write_pvf_data(fd_out, a shl 10);
   d := SmallInt((d * Mx[nbits - 2][e] + $2000) shr 14);

   if (d < 5) then d := 5;
  End;
 Until (fd_in.Position = fd_in.Size) and (s.nleft = 0);

 result := true;
End;

function pvftozyxel(fd_in, fd_out: TMemoryStream; nbits: integer; header_in: Tpvf_header): Boolean;
Var
   s:    state_t;
   a:    SmallInt;
   d:    SmallInt;
   sign: ShortInt;
   e:    Word;


//   a: SmallInt;
//   d: SmallInt;
//   s: state_t;
//   e: SmallInt;
   nmax: Byte;
//   sign: integer;
   delta: SmallInt;
   data_new: integer;
Begin
 FillChar(s,sizeof(s),#0);
 a := 0;
 d := 5;

 While fd_in.Position < fd_in.Size Do
  Begin
   data_new := header_in.read_pvf_data(fd_in);
   e := 0;
   nmax := 1 shl (nbits - 1);
   delta := SmallInt((data_new shr 10) - a);

   if (delta < 0) then
    Begin
     e := nmax;
     delta := -delta;
    End;

   Dec(nmax);
   while((nmax > 0) and (delta > d)) Do
    Begin
     delta := delta - d;
     Inc(e);
     Dec(nmax);
    End;
   if ((nbits = 4) and ((e and $0f) = 0)) then e := $08;

   header_in.WriteProcedures.write_bits(fd_out, nbits, e, s);
   a := SmallInt((a * 4093 + 2048) shr 12);
   if ((e shr (nbits - 1)) = 0) then sign := 1
                                Else sign := -1;
   e := e and bitmask[nbits - 1];
   a := SmallInt(a + (sign * ((e shl 1) + 1) * d shr 1));

   if ((d and 1) <> 0) then Inc(a);

   d := SmallInt((d * Mx[nbits - 2][e] + $2000) shr 14);

   if (d < 5) then d := 5;
  End;

 if (s.nleft > 0) then header_in.WriteProcedures.write_bits(fd_out, 8 - s.nleft, $00, s);
 result := true;
End;

end.
